import pygame

from pygame.locals import *
from Vector2 import *

class Anim(object):
	def __init__(self):
		self.animTweaker = 1.0
		self.pos = Vec2d(0, 0)
		self.columns = 1
		self.rows = 1
		self.size = Vec2d(0, 0)
		self.v = 5
		self.running = False
		self.looping = False
		
	def initialize(self, rows, columns, path):
		self.columns = columns
		self.rows = rows
		self.img = pygame.image.load(path)
		self.size = Vec2d(self.img.get_width()/columns, self.img.get_height()/rows)
		
		
	def update(self, dt, v=None):
		if self.running == True:
			if not v == None:
				if v < 0:
					v*=-1
				self.v = v / 100.0
				
			self.pos.x += self.v*dt*self.animTweaker
			if self.pos.x >= self.columns:
				self.pos.x = 0
				if self.looping == False:
					self.running = False
			
		
	def render(self, game, pos, rot=0):
		surf = self.img.subsurface(pygame.Rect(int(self.pos.x)*self.size.x, int(self.pos.y)*self.size.y, int(self.size.x), int(self.size.y)))
		surf = pygame.transform.rotate(surf, rot)
		game.draw(surf, pos)
		self.currentSubSurf = surf

	def play(self):
		self.running = True
