import pygame

from Vector2 import *
from pygame.locals import *
from Entity import *


class Camera(Entity):
	def __init__(self, game, pos_vec, size_vec, level_size_vec):
		Entity.__init__(self)
		
		self.game = game
		self.pos = pos_vec
		self.size = size_vec
		self.bounds = level_size_vec
		self.vmax = 400
		self.v = self.vmax
		
	def update(self, dt):
		player = self.game.player
		
		targetVec = Vec2d(player.pos.x-0.5*self.size.x, 0) - self.pos
		
		dist = targetVec.get_length()
	
		if dist > 0:
	
			tweaker = 0.3;

			self.v =  dist / 1 * tweaker   

			if self.v > self.vmax:
				self.v = self.vmax
		
		
		self.pos += targetVec.normalized()*self.v*dt
		
			
		if self.pos.x < 0:
			self.pos.x = 0
		if self.pos.y < 0:
			self.pos.y = 0
		if self.pos.x > self.bounds.x - self.size.x:
			self.pos.x = self.bounds.x - self.size.x
		if self.pos.y > self.bounds.y - self.size.y:
			self.pos.y = self.bounds.y - self.size.y
		
