from Entity import *

class EntityManager(object):
  
    def __init__(self):
        self.entities = []
    
    
    
    def addEntity(self, entity):
        if issubclass(entity.__class__, Entity):
            self.entities.append(entity)
            self.updateLists()
      
    def removeEntity(self, entity):
        self.entities.remove(entity)
        self.updateLists()
      
    def getEntity(self, id):
        for entity in self.entities:
            if entity.id == id:
                return entity
        print("EntityManager: ERROR: Entity not found")
        return None
    
    def updateLists(self):
        return
		
    def getAll(self):
        return self.entities

    def update(self, dt):
        self.renderable = []
        self.movingCollidable = []
        self.collidable = []
        self.rrrenderable = []
		
        for entity in self.entities:
            if entity.doomed == True:
                self.removeEntity(entity)
                continue
            if hasattr(entity, "update"):
                entity.update(dt)
            if hasattr(entity, "render"):
                self.renderable.append(entity)
            if hasattr(entity, "rrrender"):
                self.rrrenderable.append(entity)
                
            if hasattr(entity, "getRect"):
                if hasattr(entity, "move"):
                    self.movingCollidable.append(entity)
                self.collidable.append(entity)
					
    def getRenderable(self):
        return self.renderable
        
    def getMovingCollidable(self):
        return self.movingCollidable
        
    def getCollidable(self):
        return self.collidable
        
    def getRrrenderable(self):
        return self.rrrenderable
        
    def cleanup(self):
		self.renderable = []
		self.movingCollidable = []
		self.collidable = []
		self.rrrenderable = []
		
		self.entities = []
