from Vector2 import *

from Knickknack import *
from Saw import *
from Plasmacannon import *
from Table import *
from Wall import *
from Drink import *

class Factory(object):
	def __init__(self, state):
		self.state = state
		self.inverted = False
	
	def createKK(self, x, y, path):
		kk = KnickKnack(self.state)
		kk.initialize(Vec2d(0, 0), path)
		kk.pos = self.convertCoords(x, y, kk.size.y)
		self.state.entityManager.addEntity(kk)
		
	
	def createTable(self, x, y, onGround=False):
		table = Table(self.state, Vec2d(0, 0))
		table.pos = self.convertCoords(x, y, table.size.y)
		table.updateRect()
		
		self.state.entityManager.addEntity(table)
	
	def createSaw(self, x, y, rotation=0.0):
		saw = Saw(self.state)
		
		pos = self.convertCoords(x, y, saw.size.y)
		
		
		saw.initialize(pos, rotation)
		self.state.entityManager.addEntity(saw)

	def createPlasmaCannon(self, x, y, rotationFactor=0, fireRate=0.5, fireAmount=1, plasmaSpeed=100, startTime=0.0):
		cannon = PlasmaCannon(self.state)
		cannon.fireTime = startTime
		pos = self.convertCoords(x, y, cannon.size.y)
		
			
		cannon.initialize(pos, rotationFactor, fireRate, fireAmount, plasmaSpeed)
		self.state.entityManager.addEntity(cannon)
		
	def createWall(self, x, y, width, height, color=None):
		pos = self.convertCoords(x, y, height)
		rect = pygame.Rect(pos.x, pos.y, width, height)
		wall = Wall(self.state, rect, color)
		self.state.entityManager.addEntity(wall)
		
	def convertCoords(self, x, y, height):
		if self.inverted:
			y = 1080-y-height
		
		return Vec2d(x, y)
		
	def createDrink(self, x, y, color=1):
		pos = Vec2d(x, y)
		drink = Drink(self.state, pos, color)
		self.state.entityManager.addEntity(drink)
		
