import pygame, sys
import Config
from pygame.locals import *

from GameState import *
from Menu import *



class Game(object):
    def __init__(self):
        pygame.init()
        self.FPS = 20.0
        self.frameClock = pygame.time.Clock()
        self.width, self.height = Config.X, Config.Y
        self.newState = False
        
        if Config.FULLSCREEN:
            self.DISPLAYSURF = pygame.display.set_mode((self.width, self.height), pygame.DOUBLEBUF, pygame.FULLSCREEN)
        else:
            self.DISPLAYSURF = pygame.display.set_mode((self.width, self.height), pygame.DOUBLEBUF)
        pygame.display.set_caption("The Lab v1.0")

        self.entityManager = EntityManager()
        self.gameStates = []
        

    def changeState(self, state):
        
        
        if issubclass(state.__class__, GameState):
            self.gameStates = []		
            self.gameStates.append(state)
            self.newState = True
        else:
            print("EVIL: STATE IST GAR KEIN STATE")
            print("ZIEHE NOTBREMSE!")
            self.exit()


    def handleEvents(self):
        if self.newState:
            self.newState = False
        self.gameStates[-1].handleEvents()

    def update(self, dt):
        
        if self.newState:
            return
        self.gameStates[-1].update(dt)
        return

    def render(self):
        if self.newState:
            return
        self.gameStates[-1].render()
        return

    def run(self):
        while True:
            dt = self.frameClock.tick(self.FPS)/ 1000.0
            #dt = 1.0/self.FPS

            self.handleEvents()
            self.update(dt)
            self.render()

    def exit(self):
        pygame.quit()
        sys.exit()

game = Game()
game.changeState(Menu(game))
game.run()
