import pygame
from pygame import *

from Entity import *
from Vector2 import *

class GasCloud(Entity):
	def __init__(self, player, state, pos):
		Entity.__init__(self)
		
		self.state = state
		self.player = player
		self.pos = pos
		
		self.img = pygame.image.load("Assets/cloud.png")
		self.size = Vec2d(self.img.get_width(), self.img.get_height())
		
		self.timer = 0
		self.lifeTime = 10.0
		
		self.attached = False
		
		
		
	def update(self, dt):
		self.timer += dt
		
		if self.timer > self.lifeTime:
			self.player.onCloud = False
			self.player.onGround = False
			
			self.doomed = True
			return
		
		
		self.allRect = pygame.Rect(self.pos.x, self.pos.y, self.size.x, self.size.y)
		
		if self.allRect.colliderect(self.player.getRect()):
			self.attached = True
			self.player.onCloud = True
			self.player.onGround = False
			if not self.player.cloud == None and not self.player.cloud == self:
				self.player.cloud.doomed = True
			self.player.cloud = self
			
		
		if self.attached:
			self.pos = Vec2d(self.player.pos.x-0.2*self.size.x, self.player.pos.y+0.6*self.player.size.y)
			
	def rrrender(self):
		self.state.draw(self.img, self.pos)
	
		
