from Vector2 import *
from Camera import *
from Level import *


class Level6(Level):
	def __init__(self, game):
		self.game = game
		self.coordsInverted = True
		self.bounds = Vec2d(5000, 1080)
		self.camera = Camera(self.game, Vec2d(0, 0), Vec2d(1920, 1080), self.bounds)
		self.game.entityManager.addEntity(self.camera)
			
		self.game.startPos = Vec2d(100, 2875)
		self.game.factory.inverted = self.coordsInverted
		
		self.createLevel()

	def createLevel(self):
		f = self.game.factory
		
		f.createWall(0, 402, 542, 162)
		f.createWall(-5, 537, 765, 168)
		f.createWall(931, 434, 154, 74)
		f.createWall(1062, 767, 860, 64)
		f.createWall(1580, -65, 342, 765)
		f.createWall(1262, 337, 332, 45)
		f.createWall(2048, 642, 194, 451)
		f.createWall(2222, 417, 437, 694)
		f.createWall(2620, 805, 168, 342)
		f.createWall(2625, 417, 162, 97)
		f.createWall(3480, -85, 302, 402)
		f.createWall(3480, 552, 165, 34)
		f.createWall(4574, 348, 565, 808)

		f.createTable(177, 0)
		f.createTable(963, 0)
		f.createTable(2875, 0)
		f.createTable(2875, 220)
		f.createTable(2845, 440)
		f.createTable(2900, 660)
		f.createTable(2900, 880)

		f.createSaw(295, 402, 180)
		f.createSaw(787, 0, 0)
		f.createSaw(1095, 0, 0)
		f.createSaw(1922, 47, 270)
		f.createSaw(2238, 0, 0)
		f.createSaw(2561, 0, 0)
		f.createSaw(3467, 556, 0)
		f.createSaw(3598, 317, 0)
		f.createSaw(3981, 0, 0)
		f.createSaw(4341, 0, 0)

		f.createPlasmaCannon(760, 650, 270, 4.0, 1, 300)
		f.createPlasmaCannon(0, 904, 270, 4.0, 1, 300)
		f.createPlasmaCannon(2424, 368, 180, 6, 2)
		f.createPlasmaCannon(3333, 0, 0, 5.5, 1, 200)

		
		
		
		
		
		
