import pygame
from pygame.locals import *
from Vector2 import *

from GameState import *
from Ingame import *
from Credits import *


class Menu(GameState):
    def __init__(self, game):
        GameState.__init__(self, game)
		
        self.logo = pygame.image.load("Assets/Menu/logo.png")
        self.play = pygame.image.load("Assets/Menu/play.png")
        self.credits_img = pygame.image.load("Assets/Menu/credits.png")
        self.quit_img = pygame.image.load("Assets/Menu/quit.png")
        self.title = pygame.image.load("Assets/Menu/title.png")
        self.RENDERSURF = pygame.Surface((1920, 1080))
        
        self.scalingFactor = self.game.width / 1920.0
        
        self.playPos = self.convertCoords(1080, 610, self.play.get_height())
        self.logoPos = self.convertCoords(50, 50, self.logo.get_height())
        self.creditsPos = self.convertCoords(1080, 440, self.credits_img.get_height())
        self.quitPos = self.convertCoords(1080, 270, self.quit_img.get_height())
        self.titlePos = self.convertCoords(1080, 830, self.title.get_height())
        
        self.playRect = pygame.Rect(self.playPos.x*self.scalingFactor, self.playPos.y*self.scalingFactor, self.play.get_width()*self.scalingFactor, self.play.get_height()*self.scalingFactor)
        self.creditsRect = pygame.Rect(self.creditsPos.x*self.scalingFactor, self.creditsPos.y*self.scalingFactor, self.credits_img.get_width()*self.scalingFactor, self.credits_img.get_height()*self.scalingFactor)
        self.quitRect = pygame.Rect(self.quitPos.x*self.scalingFactor, self.quitPos.y*self.scalingFactor, self.quit_img.get_width()*self.scalingFactor, self.quit_img.get_height()*self.scalingFactor)

		
    def handleEvents(self):
        self.events = pygame.event.get()
		
        for event in self.events:
            if event.type == QUIT:
                self.game.exit()
            if event.type == KEYUP:
                if event.key == K_ESCAPE:
                    self.game.exit()
            if event.type ==  MOUSEBUTTONDOWN:
                if event.button == 1:
                    self.checkClicked(event.pos)
	
    def checkClicked(self, pos):
        if self.playRect.collidepoint(pos):
            self.game.changeState(InGame(self.game))
        if self.creditsRect.collidepoint(pos):
            self.game.changeState(Credits(self.game))
        if self.quitRect.collidepoint(pos):
            self.game.exit()

    def update(self, dt):
        return
		
    def render(self):
        self.RENDERSURF.fill(pygame.Color(255, 255, 255))
		
        self.RENDERSURF.blit(self.logo, self.logoPos)
        self.RENDERSURF.blit(self.title, self.titlePos)
        self.RENDERSURF.blit(self.play, self.playPos)
        self.RENDERSURF.blit(self.credits_img, self.creditsPos)
        self.RENDERSURF.blit(self.quit_img, self.quitPos)
		
        pygame.transform.scale(self.RENDERSURF, (self.game.width, self.game.height), self.game.DISPLAYSURF)
        pygame.display.flip()
		
    def convertCoords(self, x, y, height):
        y = 1080-y-height
        return Vec2d(x, y)
