import pygame
from pygame.locals import *

from Vector2 import *
from Entity import *
from Anim import *

class Saw(Entity):
	def __init__(self, game):
		Entity.__init__(self)
		
		self.game = game
		self.pos = Vec2d(0, 0)
		self.anim = Anim()
		self.anim.initialize(1, 16, "Assets/saw.png")
		self.anim.looping = True
		self.size = self.anim.size
		self.anim.animTweaker = 2.0
		self.useMask = True
		self.anim.running = True
		self.rotation = 0
		
	def initialize(self, pos, rotation):
		self.pos = pos
		self.rotation = rotation
		
		if self.rotation == 0 or self.rotation == 180:
			self.allRect = pygame.Rect(self.pos.x+self.size.x*0.2, self.pos.y+self.size.y*0.2, self.size.x*0.6, self.size.y*0.6)
		if self.rotation == 90 or self.rotation == 270 or self.rotation == -90:
			self.allRect = pygame.Rect(self.pos.x+self.size.x*0.2, self.pos.y+self.size.y*0.2, self.size.y*0.6, self.size.x*0.6)
		
		
	def update(self, dt):
		self.anim.update(dt)
		
	def render(self):
		self.anim.render(self.game, self.pos, self.rotation)

	def getRect(self):
		return self.allRect
		
	def onCollision(self, victim):
		#victimradius = (victim.size.x/2.0+victim.size.y/2.0)/2.0
		#if victimradius+self.r < (self.pos-victim.pos).get_length():
		if hasattr(victim, "die"):
			victim.die()

	def getMask(self):
		return pygame.mask.from_surface(self.anim.currentSubSurf)
