import pygame
from pygame.locals import *

from Entity import *
from Vector2 import *

class Wall(Entity):
	def __init__(self, state, rect, color=None):
		Entity.__init__(self)
		
		self.state = state
		self.rect = rect
		self.img = pygame.Surface((self.rect.width, self.rect.height))
		if not color == None:
			self.color = color
		else:
			self.color = pygame.Color(200, 208, 208)
		self.img.fill(self.color)
		
		
	def getRect(self):
		return self.rect
		
	def onCollision(self, entity):
		return
		
	def render(self):
		self.state.draw(self.img, Vec2d(self.rect.x, self.rect.y))
